module     p0_ddbar_emepg_d69h6l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/Z1jet/1.4/Virtual/p
   ! 0_ddbar_emepg/helicity6/d69h6l1.f90
   ! generator: haggies (1.1)
   use p0_ddbar_emepg_config, only: ki
   use p0_ddbar_emepg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_ddbar_emepg_groups, only: &
!           & sign => diagram69_sign, shift => diagram69_shift
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh6
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d69
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d69 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t6 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d69 = (abb69n1+t1*abb69n10+t2*abb69n2+t3*abb69n3+t4*abb69n4+t5*abb69n5+t6*&
      &abb69n6+t7*abb69n7+t1*t5*abb69n9+t2*t5*abb69n9+t2*t6*abb69n17+t2*t8*abb69&
      &n13+t3*t6*abb69n19+t3*t8*abb69n12+t4*t6*abb69n20+t4*t8*abb69n11+t5*t6*abb&
      &69n16+t5*t7*abb69n14+t5*t8*abb69n15+t5*abb69n18*(Q(1)*spvak1k5(1)-Q(2)*sp&
      &vak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))+t5*abb69n21*(Q(1)*spvak1k4(1&
      &)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))+t6*t7*abb69n8+t5*t6&
      &*t7*abb69n22)
      numerator = cmplx(real(d69, ki), aimag(d69), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_ddbar_emepg_globalsl1, only: epspow
      use p0_ddbar_emepg_kinematics
      use p0_ddbar_emepg_abbrevh6
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d69
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d69 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t5 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t6 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))
      d69 = (abb69n1+t1*abb69n10+t2*abb69n2+t3*abb69n3+t4*abb69n4+t5*abb69n5+t6*&
      &abb69n6+t7*abb69n7+t1*t5*abb69n9+t2*t5*abb69n9+t2*t6*abb69n17+t2*t8*abb69&
      &n13+t3*t6*abb69n19+t3*t8*abb69n12+t4*t6*abb69n20+t4*t8*abb69n11+t5*t6*abb&
      &69n16+t5*t7*abb69n14+t5*t8*abb69n15+t5*abb69n18*(Q(1)*spvak1k5(1)-Q(2)*sp&
      &vak1k5(2)-Q(3)*spvak1k5(3)-Q(4)*spvak1k5(4))+t5*abb69n21*(Q(1)*spvak1k4(1&
      &)-Q(2)*spvak1k4(2)-Q(3)*spvak1k4(3)-Q(4)*spvak1k4(4))+t6*t7*abb69n8+t5*t6&
      &*t7*abb69n22)

      numerator = cmplx(real(d69, ki), aimag(d69), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_ddbar_emepg_d69h6l1
